#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <bios.h>
#include <dir.h>
#include <malloc.h>
#include <dos.h>

#define RB_VERSION     1
#define RB_REVISION    0
#define RB_DAY         26
#define RB_MONTH       6
#define RB_YEAR        1998

unsigned hi(unsigned val)
{
     _AX=val;
     return _AH;
}

void main(int argc, char *argv[])
{
     char *buffer;
     int lw,result;
     FILE *Fptr;

     printf("BOOT Sector Writer V%d.%02d.\n"
            "(C) %d.%d.%d by Leo Eibler.\n", RB_VERSION, RB_REVISION,
            RB_DAY, RB_MONTH, RB_YEAR);
     argc--;
     if(argc<1)
     {
       printf("Syntax: WRTBOOT File.Ext [HD-Drive:]\n");
       return;
     }
     strcpy(argv[1], strupr(argv[1]));

     lw=getdisk();

     if(argc>1)
     {
       strcpy(argv[2], strupr(argv[2]));
       lw=argv[2][0]-'A';
     }

     printf("Dive %c:\n", lw+'A');

     buffer=(char *)malloc(512+1);
     if(buffer==0)
     {
       printf("Error: Not enough memory.\n");
       return;
     }

     Fptr=fopen(argv[1], "rb");
     if(Fptr==0)
     {
       printf("Error: Can't open %s.\n", argv[1]);
       free(buffer);
       return;
     }
     result=fread(buffer, 1, 512, Fptr);
     if(result!=512)
     {
       printf("Warning: Read %d Bytes (but should be %d Bytes).\n",
              result, 512);
       fclose(Fptr);
       free(buffer);
       return;
     }
     printf("%d Bytes successfully read from %s.\n", result, argv[1]);
     fclose(Fptr);

     result=abswrite(lw, 1, 0, buffer);

     if(result!=0)
     {
       printf("Error: An Error occured while writing bootsector to Drive "
              "%c:.\n", lw+'A');
       printf("       Code %Xh\n", result);
       free(buffer);
       return;
     }
     free(buffer);
}
